'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Adverts = function () {
	function Adverts(enabled, rewarded_placementId, interstitial_placementId) {
		_classCallCheck(this, Adverts);

		if (typeof rewarded_placementId !== 'undefined') {
			this.rewarded_placementId = rewarded_placementId;
		} else {
			this.rewarded_placementId = typeof Settings !== 'undefined' ? Settings.adverts.rewarded_placementId : false;
		}

		if (typeof interstitial_placementId !== 'undefined') {
			this.interstitial_placementId = interstitial_placementId;
		} else {
			this.interstitial_placementId = typeof Settings !== 'undefined' ? Settings.adverts.interstitial_placementId : false;
		}

		this.rewarded_instance = null;
		this.interstitial_instance = null;

		this._loaded = false;

		if (typeof enabled !== 'undefined') {
			this.enabled = enabled;
		} else {
			// backward compat
			this.enabled = typeof Settings !== 'undefined' ? Settings.adverts.enabled : false;
		}
	}

	/*
        callback: (optional) the callback to execute when instance retrieved
        waitForLoad: (optional) callback to execute when video is preloaded
     */


	_createClass(Adverts, [{
		key: 'initialize',
		value: function initialize(callback, waitForLoad) {
			'use strict';

			var self = this;

			console.log('[Adverts] Initializing ad instance');

			if (this.enabled === false || typeof FBInstant === 'undefined') {
				if (callback) callback();
				if (waitForLoad) waitForLoad();
				return;
			}

			var rewardedAdDone = false;
			var interstitialAdDone = false;
			this._getAndLoadRewardedAdInstance(function () {
				rewardedAdDone = true;
				if (interstitialAdDone === true) {
					if (callback) {
						callback();
					}
				}
			});

			this._getAndLoadInterstitialAdInstance(function () {
				interstitialAdDone = true;
				if (rewardedAdDone === true) {
					if (callback) {
						callback();
					}
				}
			});
		}
	}, {
		key: '_getAndLoadInterstitialAdInstance',
		value: function _getAndLoadInterstitialAdInstance(callback, waitForLoad) {
			var self = this;

			if (this.interstitial_instance) return;

			FBInstant.getInterstitialAdAsync(this.interstitial_placementId).then(function (interstitial) {
				console.log('[Adverts] Loaded ad interstitial_instance');
				self.interstitial_instance = interstitial;
				self.interstitial_instance.loadAsync().then(function (retVal) {
					console.log('[Adverts] Preloaded interstitial ad');
					if (waitForLoad) waitForLoad();
				}).catch(function (err) {
					switch (err) {
						case 'ADS_FREQUENT_LOAD':
						case 'ADS_NO_FILL':
						case 'INVALID_PARAM':
						case 'NETWORK_FAILURE':
							break;
					}

					console.error('[Adverts] Load interstitial ad failed! ' + err.code);
					console.error(err.message);

					if (waitForLoad) waitForLoad();
				});
				if (callback) callback();
			}).catch(function (err) {
				switch (err) {
					case 'ADS_TOO_MANY_INSTANCES':
					case 'CLIENT_UNSUPPORTED_OPERATION':
						break;
				}

				console.error('[Adverts] Get ad interstitial failed! ' + err.code);
				console.error(err.message);

				if (callback) callback();
				if (waitForLoad) waitForLoad();
			});
		}
	}, {
		key: '_getAndLoadRewardedAdInstance',
		value: function _getAndLoadRewardedAdInstance(callback, waitForLoad) {
			var self = this;

			if (this.rewarded_instance) return;

			FBInstant.getRewardedVideoAsync(this.rewarded_placementId).then(function (rewardedVideo) {
				console.log('[Adverts] Loaded ad rewarded_instance');
				self.rewarded_instance = rewardedVideo;
				self.rewarded_instance.loadAsync().then(function (retVal) {
					console.log('[Adverts] Preloaded rewarded ad');
					if (waitForLoad) waitForLoad();
				}).catch(function (err) {
					switch (err) {
						case 'ADS_FREQUENT_LOAD':
						case 'ADS_NO_FILL':
						case 'INVALID_PARAM':
						case 'NETWORK_FAILURE':
							break;
					}

					console.error('[Adverts] Load rewarded ad failed! ' + err.code);
					console.error(err.message);

					if (waitForLoad) waitForLoad();
				});
				if (callback) callback();
			}).catch(function (err) {
				switch (err) {
					case 'ADS_TOO_MANY_INSTANCES':
					case 'CLIENT_UNSUPPORTED_OPERATION':
						break;
				}

				console.error('[Adverts] Get ad rewarded_instance failed! ' + err.code);
				console.error(err.message);

				if (callback) callback();
				if (waitForLoad) waitForLoad();
			});
		}
	}, {
		key: 'showRewardedAd',
		value: function showRewardedAd(callback) {
			'use strict';

			var self = this;

			if (this.enabled === false) {
				if (callback) callback();
				return;
			}

			if (!this.rewarded_instance) {
				console.error('[Adverts] showAd failed! Ad not loaded!');
				if (callback) callback();
				return;
			}

			this.rewarded_instance.showAsync().then(function () {
				if (callback) callback();
				self.rewarded_instance = null;
				self._getAndLoadRewardedAdInstance();
			}).catch(function (err) {
				// ad not watched
				switch (err) {
					case 'ADS_NOT_LOADED':
					case 'INVALID_PARAM':
					case 'NETWORK_FAILURE':
						break;
				}
				console.error('[Adverts] showRewardedAd failed! ' + err.code);
				console.log(err.message);
				console.log(err);

				if (callback) callback();
			});
		}
	}, {
		key: 'showInterstitialAd',
		value: function showInterstitialAd(callback) {
			'use strict';

			var self = this;

			if (this.enabled === false) {
				if (callback) callback();
				return;
			}

			if (!this.interstitial_instance) {
				console.error('[Adverts] showAd failed! Ad not loaded!');
				if (callback) callback();
				return;
			}

			this.interstitial_instance.showAsync().then(function () {
				if (callback) callback();
				self.interstitial_instance = null;
				self._getAndLoadInterstitialAdInstance();
			}).catch(function (err) {
				// ad not watched
				switch (err) {
					case 'ADS_NOT_LOADED':
					case 'INVALID_PARAM':
					case 'NETWORK_FAILURE':
						break;
				}
				console.error('[Adverts] showInterstitialAd failed! ' + err.code);
				console.log(err.message);
				console.log(err);

				if (callback) callback();
			});
		}
	}]);

	return Adverts;
}();

module.exports = Adverts;