'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/*
	Analytics wrapper
 */

var Analytics = function () {
	function Analytics(enabled, debug) {
		_classCallCheck(this, Analytics);

		// this.cid = null;
		// this.tid = Settings.Analytics.tid;
		// this.mode = Settings.Analytics.mode;
		// this.enabled = Settings.Analytics.enabled;
		// this._debug = Settings.Analytics.debug;

		this.mode = 'FBINSTANT';

		if (typeof enabled !== 'undefined') {
			this.enabled = enabled;
		} else {
			// backward compat
			this.enabled = typeof Settings !== 'undefined' ? Settings.Analytics.enabled : false;
		}

		if (typeof debug !== 'undefined') {
			this._debug = debug;
		} else {
			// backward compat
			this._debug = typeof Settings !== 'undefined' ? Settings.Analytics.debug : false;
		}

		if (this.mode === 'FBINSTANT') {
			this.initialize();
		}
	}

	_createClass(Analytics, [{
		key: 'initialize',
		value: function initialize(clientID) {
			if (this.mode === 'GOOGLE') {
				if (!clientID) {
					throw new Error('Analytics error - no CID!');
				} else {
					this.cid = clientID;
				}
			}

			if (this.mode === 'FBINSTANT' && typeof FBInstant === 'undefined') {
				this.enabled = false;
				console.warn('Analytics warning - FBInstant is undefined');
			}

			this.log('Initialized analytics');
		}
	}, {
		key: 'EnableDebugging',
		value: function EnableDebugging() {
			this._debug = true;
		}
	}, {
		key: 'log',
		value: function log(data) {
			if (this._debug) console.log(data);
		}
	}, {
		key: 'SendEvent',
		value: function SendEvent(category, action, label, value) {
			'use strict';

			var self = this;

			if (this.enabled === false) return;

			if (typeof value === 'undefined') value = 1;

			if (this.mode === 'FBINSTANT') {
				try {
					var result = FBInstant.logEvent(category, value, {
						action: action,
						label: label
					});
					if (result) {
						// We could throw an error here but analytics are not that important -Sam
						console.error('Send event ' + category + ' unsuccessfully');
					} else {
						console.log('Send event ' + category + ' successfully');
					}
				} catch (err) {
					console.error(err);
				}
			} else if (this.mode === 'GOOGLE') {
				var genData = this._generateData('event', category, action, label, value);
				this._postAjax(Settings.Analytics.url, genData, function (da) {
					self.log('Sent event of category "' + category + '" ' + genData);
				});
			}
		}
	}, {
		key: '_generateData',
		value: function _generateData(type, category, action, label, value) {
			'use strict';

			var result = '';

			result += 'v=1';
			result += '&';
			result += 'tid=' + this.tid;
			result += '&';
			result += 'cid=' + this.cid;
			result += '&';
			result += 't=' + type;

			if (category) {
				result += '&';
				result += 'ec=' + category;
			}
			if (action) {
				result += '&';
				result += 'ea=' + action;
			}
			if (label) {
				result += '&';
				result += 'el=' + label;
			}
			if (value) {
				result += '&';
				result += 'ev=' + value;
			}

			return result;
		}
	}, {
		key: '_postAjax',
		value: function _postAjax(url, data, success) {
			try {
				var xhttp = new XMLHttpRequest();
				xhttp.onreadystatechange = function (retVal) {
					//console.log(retVal);
				};
				xhttp.onload = function (da) {
					if (success) success(da);
				};
				xhttp.open('GET', url + data, true);
				xhttp.send();
			} catch (err) {
				console.error(err);
				return null;
			}
		}
	}]);

	return Analytics;
}();

module.exports = Analytics;