'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PIXI = require('pixi.js');

var AnimatedGameObject = function (_PIXI$extras$Animated) {
	_inherits(AnimatedGameObject, _PIXI$extras$Animated);

	function AnimatedGameObject(textures, props) {
		'use strict';

		_classCallCheck(this, AnimatedGameObject);

		var _this = _possibleConstructorReturn(this, (AnimatedGameObject.__proto__ || Object.getPrototypeOf(AnimatedGameObject)).call(this, textures));

		_this._isAnimated = true;

		//this.filters = [new PIXI.filters.FXAAFilter()];

		_this.uid = parseInt(Math.random().toString().slice(2));

		_this.zOrder = 0;

		_this._addChild = _this.addChild;
		_this.addChild = function (obj) {
			if (obj.onAdd) obj.onAdd(_this);
			_this._addChild(obj);
		};

		_this._removeChild = _this.removeChild;
		_this.removeChild = function (obj) {
			if (obj.onRemove) obj.onRemove();
			_this._removeChild(obj);
		};

		if (props) Object.assign(_this, props);
		return _this;
	}

	_createClass(AnimatedGameObject, [{
		key: 'freeze',
		value: function freeze() {
			this._isFrozen = true;
		}
	}, {
		key: 'unfreeze',
		value: function unfreeze() {
			this._isFrozen = false;
		}
	}, {
		key: 'hide',
		value: function hide() {
			'use strict';

			this.alpha = 0;
			this._isVisible = false;
		}
	}, {
		key: 'show',
		value: function show() {
			'use strict';

			this.alpha = 1;
			this._isVisible = this.isVisible;
		}
	}, {
		key: 'onDestroy',
		value: function onDestroy() {
			/* To be overridden*/
		}
	}, {
		key: 'onRemove',
		value: function onRemove() {
			/* To be overridden*/
		}
	}, {
		key: 'onAdd',
		value: function onAdd(scene) {
			'use strict';

			this.parentScene = scene;
		}
	}, {
		key: 'endStep',
		value: function endStep() {
			if (this.isFrozen) return;
		}
	}, {
		key: 'onCollide',
		value: function onCollide() {}
	}, {
		key: 'physicsStep',
		value: function physicsStep() {}
	}, {
		key: 'destroy',
		value: function destroy() {
			if (this.onDestroy) this.onDestroy();
			if (this.parentScene) this.parentScene.removeChild(this);
		}
	}, {
		key: 'isFrozen',
		get: function get() {
			return this._isFrozen;
		}
	}, {
		key: 'vX',
		get: function get() {
			return this._vX;
		},
		set: function set(val) {
			this._vX = val;
		}
	}, {
		key: 'vY',
		get: function get() {
			return this._vY;
		},
		set: function set(val) {
			this._vY = val;
		}
	}, {
		key: 'x',
		set: function set(val) {
			this.position.x = val;
		},
		get: function get() {
			return this.position.x;
		}
	}, {
		key: 'y',
		set: function set(val) {
			this.position.y = val;
		},
		get: function get() {
			'use strict';

			return this.position.y;
		}
	}, {
		key: 'z',
		set: function set(val) {
			this.zOrder = val;
		},
		get: function get() {
			return this.zOrder;
		}
	}]);

	return AnimatedGameObject;
}(PIXI.extras.AnimatedSprite);

module.exports = AnimatedGameObject;