'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AssetLoader = function () {
	function AssetLoader() {
		_classCallCheck(this, AssetLoader);

		console.warn('Instance of AssetLoader created; it is intended to be static!');
	}

	_createClass(AssetLoader, null, [{
		key: 'LoadAssetsFromAssetList',


		/**
   *
   * @param {Object} assetList
   * @param {Object} [config]
   * @returns {Promise<any>}
   * @static
   */
		value: function LoadAssetsFromAssetList(assetList, config) {
			var self = this;
			var length = Object.keys(assetList).length;

			if (!config) {
				config = AssetLoader.DefaultConfig;
			} else {
				config = Object.assign(AssetLoader.DefaultConfig, config);
			}

			if (typeof PIXI === 'undefined') {
				throw new Error('PIXI is undefined!');
			}

			return new Promise(function (resolve, reject) {
				if (length === 0) {
					resolve();
					return;
				}

				if (PIXI.loader.loading) {
					console.error('PIXI loader is still loading!');
					reject();
				} else {
					PIXI.loader.reset();
				}

				PIXI.loader.onLoad.add(function (file, res) {
					if (!Settings.DEBUG.suppressLoadingLogs) console.log('[flowController] Loaded resource: ' + res.url);
				});

				PIXI.loader.onError.add(function (err) {
					if (config.safe) {
						if (config.verbose) console.error('[flowController] Failed to load file! ' + err.stack);
					} else reject('[flowController] Failed to load file! ' + err.stack);
				});

				var firstPromise = void 0;
				var currPromise = void 0;
				for (var k in assetList) {
					if (!assetList.hasOwnProperty(k)) continue;

					if (!firstPromise) {
						firstPromise = PIXI.loader.add(k, 'assets/' + assetList[k]);
						currPromise = firstPromise;
						continue;
					}

					currPromise = currPromise.add(k, 'assets/' + assetList[k]);
				}

				PIXI.loader.load(function (loader, resources) {
					if (!global._TEXTURES) global._TEXTURES = {};
					if (!global._OSUFILECACHE) global._OSUFILECACHE = {};

					for (var _k in resources) {
						if (resources.hasOwnProperty(_k)) {
							if (resources[_k].error) continue;

							if (!resources[_k].texture) {
								if (resources[_k].url.includes('.ogg', Math.floor(resources[_k].url.length * 0.5)) || resources[_k].url.includes('.mp3', Math.floor(resources[_k].url.length * 0.5)) || resources[_k].url.includes('.wav', Math.floor(resources[_k].url.length * 0.5))) {
									// audio is handled seperately
									resources[_k].sound.fileKey = _k;
									resources[_k].sound.__PARENT = resources[_k];
									global[_k] = resources[_k].sound;
								} else if (resources[_k].url.includes('.osu', Math.floor(resources[_k].url.length * 0.5))) {
									global._OSUFILECACHE[_k] = resources[_k].data;
								} else {
									console.warn('Asset %s is unhandled', _k);
									global[_k] = resources[_k];
								}
							} else {
								global[_k] = resources[_k].texture;
								global._TEXTURES[_k] = resources[_k].texture;
							}
						}
					}
					resolve(resources);
				});
			});
		}
	}, {
		key: 'DefaultConfig',
		get: function get() {
			return {
				'global': true,
				'safe': true,
				'verbose': false
			};
		}
	}]);

	return AssetLoader;
}();

module.exports = AssetLoader;