'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GameObject = require('./GameObject.js');

var Button = function (_GameObject) {
	_inherits(Button, _GameObject);

	function Button(upstate, downstate, props) {
		_classCallCheck(this, Button);

		var _this = _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).call(this, upstate, props));

		_this.upstateTexture = upstate;
		_this.downstateTexture = downstate;

		_this._isInDownstate = false;

		_this.interactive = true;

		_this.on('pointerup', function () {
			if (!_this._isInDownstate && !_this._isToggleButton) return;
			_this._pointerUp(true);
		});
		_this.on('pointerdown', function () {
			_this._pointerDown();
		});

		_this.on('pointerout', function () {
			_this._pointerUp(false);
		});

		if (props) {
			Object.assign(_this, props);
		}
		return _this;
	}

	_createClass(Button, [{
		key: 'isDown',
		value: function isDown() {
			return this._isInDownstate;
		}

		/**
   * @private
   */

	}, {
		key: '_pointerDown',
		value: function _pointerDown() {
			this.updateTexture(this.downstateTexture);
			this.y += this.height / 55;

			if (this.text) {
				this.text.y += this.height / 55;
			}

			this._isInDownstate = true;
		}

		/**
   * @param {Boolean} activate
   * @private
   */

	}, {
		key: '_pointerUp',
		value: function _pointerUp(activate) {
			if (this._isInDownstate) {
				this.updateTexture(this.upstateTexture);
				this.y -= this.height / 55;

				if (this.text) {
					this.text.y -= this.height / 55;
				}

				this._isInDownstate = false;

				if (activate) this.onClick();
			}
		}

		/**
   * Pure function; intended to be overwritten
   */

	}, {
		key: 'onClick',
		value: function onClick() {
			console.warn('[Button] onClick not overridden; is this intended?');
		}
	}]);

	return Button;
}(GameObject);

module.exports = Button;