'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PIXI = require('pixi.js');

var ContainerObject = function (_PIXI$Container) {
	_inherits(ContainerObject, _PIXI$Container);

	function ContainerObject(props) {
		'use strict';

		_classCallCheck(this, ContainerObject);

		//this.orientation = Math.random() < 0.5 ? 0 : 1; // 0 == down to up, 1 == up to down
		var _this = _possibleConstructorReturn(this, (ContainerObject.__proto__ || Object.getPrototypeOf(ContainerObject)).call(this));

		_this.tag = 'ContainerObject';

		_this.uid = parseInt(Math.random().toString().slice(2));

		_this._addChild = _this.addChild;
		_this.addChild = function (obj) {
			if (obj.onAdd) obj.onAdd(_this);
			_this._addChild(obj);
			_this._forceSort();
		};

		_this._removeChild = _this.removeChild;
		_this.removeChild = function (obj) {
			if (obj.onRemove) obj.onRemove();
			_this._removeChild(obj);
			_this._forceSort();
		};

		if (props) Object.assign(_this, props);
		return _this;
	}

	_createClass(ContainerObject, [{
		key: 'onAdd',
		value: function onAdd(scene) {
			'use strict';

			this.parentScene = scene;
		}
	}, {
		key: 'onDestroy',
		value: function onDestroy() {
			/* To be overridden*/
		}
	}, {
		key: 'onRemove',
		value: function onRemove() {
			/* To be overridden*/
		}
	}, {
		key: '_forceSort',
		value: function _forceSort() {
			this.children.sort(function (a, b) {
				if (!a.zOrder) a.zOrder = 0;
				if (!b.zOrder) b.zOrder = 0;
				if (a.zOrder === b.zOrder) return 0;else return a.zOrder < b.zOrder ? -1 : 1;
			});
		}
	}, {
		key: 'destroy',
		value: function destroy() {
			if (this.onDestroy) this.onDestroy();
			if (this.parentScene) this.parentScene.removeChild(this);
		}
	}, {
		key: 'endStep',
		value: function endStep(dt) {
			'use strict';

			for (var k = 0; k < this.children.length; k++) {
				if (this.children[k].endStep) this.children[k].endStep(dt);
			}
		}
	}, {
		key: 'x',
		set: function set(val) {
			this.position.x = val;
		},
		get: function get() {
			return this.position.x;
		}
	}, {
		key: 'y',
		set: function set(val) {
			this.position.y = val;
		},
		get: function get() {
			return this.position.y;
		}
	}, {
		key: 'z',
		set: function set(val) {
			this.zOrder = val;
		},
		get: function get() {
			return this.zOrder;
		}
	}]);

	return ContainerObject;
}(PIXI.Container);

module.exports = ContainerObject;