'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var EventObject = require('./EventObject.js');

var EventHandler = function () {
	function EventHandler(ticker) {
		_classCallCheck(this, EventHandler);

		this._ticker = ticker;
		this._ticker.add(this._loop.bind(this));

		this._queue = [];
	}

	_createClass(EventHandler, [{
		key: '_loop',
		value: function _loop() {
			var dt = this._ticker.elapsedMS;

			for (var i = this._queue.length - 1; i >= 0; i--) {
				if (this._queue[i].isComplete === true) {
					this._queue.splice(i, 1);
				}
			}

			for (var _i = 0; _i < this._queue.length; _i++) {
				this._queue[_i].update(dt);
			}
		}

		/**
   *
   * @param {function} func Function to call when the event fires
   * @param {number} timer
   * @param {boolean} [loop]
   * @returns {object} The created event object (optional)
   * @constructor
   */

	}, {
		key: 'ScheduleEvent',
		value: function ScheduleEvent(func, timer, loop) {
			var event = new EventObject(func, timer, loop);
			this._queue.push(event);
			return this._queue[this._queue.length - 1];
		}
	}]);

	return EventHandler;
}();

module.exports = EventHandler;