'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var EventObject = function () {
	function EventObject(func, timer, loop) {
		_classCallCheck(this, EventObject);

		if (!func || typeof func !== 'function') console.error('EventObject - No function supplied!');

		this._func = func;

		this._timer = 0;
		this._timerThreshold = timer;
		this._loop = !!loop;

		this._isComplete = false;
		this._isPaused = false;
	}

	_createClass(EventObject, [{
		key: 'update',
		value: function update(dt) {
			if (this.isComplete || this.isPaused) return;

			this._timer += dt;
			if (this._timer >= this._timerThreshold) {
				this._isComplete = !this._loop;
				this._func();
			}
		}
	}, {
		key: 'stop',
		value: function stop() {
			this._isComplete = true;
		}
	}, {
		key: 'pause',
		value: function pause() {
			this._isPaused = true;
		}
	}, {
		key: 'play',
		value: function play() {
			this._isPaused = false;
		}
	}, {
		key: 'unpause',
		value: function unpause() {
			this.play();
		}
	}, {
		key: 'isLooping',
		get: function get() {
			return this._loop;
		}
	}, {
		key: 'isPaused',
		get: function get() {
			return this._isPaused;
		}
	}, {
		key: 'isComplete',
		get: function get() {
			return this._isComplete;
		}
	}]);

	return EventObject;
}();

module.exports = EventObject;