'use strict';

var __miscPolyFillInit = function __miscPolyFillInit() {
	if (global.__hasInitPolyfills) return;

	global._ATLAVER = '1.0.0';

	// https://stackoverflow.com/questions/7616461/generate-a-hash-from-string-in-javascript-jquery
	String.prototype.generateUID = function () {
		var hash = 0,
		    i = void 0,
		    chr = void 0;
		if (undefined.length === 0) return hash;
		for (i = 0; i < undefined.length; i++) {
			chr = undefined.charCodeAt(i);
			hash = (hash << 5) - hash + chr;
			hash |= 0; // Convert to 32bit integer
		}
		return Math.floor(hash * Math.random());
	};

	global.renderScale = function (x) {
		return x * (global.Settings ? Settings.applicationSettings.renderScale : 1.0);
	};

	global.lerp = function (v0, v1, t) {
		return v0 * (1 - t) + v1 * t;
	};

	global.SetRendererProperties = function (rendererView, style) {
		'use strict';

		if (!style) {
			rendererView.style = Object.assign(rendererView.style, window.Settings ? Settings.styleSettings : {});
		} else {
			rendererView.style = Object.assign(rendererView.style, style);
		}
	};

	global.Tokens = [];

	global.AddToken = function (token) {
		Tokens.push(token);
		if (token.onAdd) token.onAdd();
		return Tokens[Tokens.length - 1];
	};

	global.RemoveToken = function (token) {
		for (var i = 0; i < Tokens.length; i++) {
			if (Tokens[i].uid === token.uid) {
				Tokens[i]._queuedForDestruction = true;
				if (Tokens[i].onRemove) Tokens[i].onRemove();
				return;
			}
		}
	};

	global.UpdateTokens = function (deltaTime) {
		for (var i = 0; i < Tokens.length; i++) {
			if (!Tokens[i]._queuedForDestruction && Tokens[i].startStep) {
				Tokens[i].startStep(deltaTime);
			}
		}
		for (var _i = 0; _i < Tokens.length; _i++) {
			if (!Tokens[_i]._queuedForDestruction && Tokens[_i].endStep) {
				Tokens[_i].endStep(deltaTime);
			}
		}
		for (var _i2 = Tokens.length - 1; _i2 >= 0; _i2--) {
			if (Tokens[_i2]._queuedForDestruction) {
				Tokens[_i2] = null;
				Tokens.splice(_i2, 1);
			}
		}
	};

	global.__hasInitPolyfills = true;
};

module.exports = __miscPolyFillInit();