'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PIXI = require('pixi.js');

var NineSliceObject = function (_PIXI$mesh$NineSliceP) {
	_inherits(NineSliceObject, _PIXI$mesh$NineSliceP);

	/**
  *
  * @param {PIXI.Texture} texture
  * @param {object} props
  * @param {number} [leftWidth]
  * @param {number} [topHeight]
  * @param {number} [rightWidth]
  * @param {number} [bottomHeight]
  */
	function NineSliceObject(texture, props, leftWidth, topHeight, rightWidth, bottomHeight) {
		_classCallCheck(this, NineSliceObject);

		if (typeof props === 'undefined') {
			throw new Error('No properties passed to NineSlice!');
		}

		if (typeof leftWidth === 'undefined') {
			if (!props.hasOwnProperty('leftWidth') || !props.hasOwnProperty('topHeight') || !props.hasOwnProperty('rightWidth') || !props.hasOwnProperty('bottomHeight')) {
				throw new Error('Missing required nineslice properties! (refer to documentation)');
			} else {
				leftWidth = props.leftWidth;
				topHeight = props.topHeight;
				rightWidth = props.rightWidth;
				bottomHeight = props.bottomHeight;
			}
		}

		var _this = _possibleConstructorReturn(this, (NineSliceObject.__proto__ || Object.getPrototypeOf(NineSliceObject)).call(this, texture, leftWidth, topHeight, rightWidth, bottomHeight));

		if (props) {
			Object.assign(_this, props);
		}
		return _this;
	}

	_createClass(NineSliceObject, [{
		key: 'smartScale',
		value: function smartScale(x, y) {
			'use strict';

			if (this.width === 0 || this.height === 0) {
				console.error('divide by zero!');
				return;
			}

			if (x) {
				this.scale.x = x / this.width;
				if (!y) {
					this.scale.y = this.scale.x;
				}
			}
			if (y) {
				this.scale.y = y / this.height;
				if (!x) {
					this.scale.x = this.scale.y;
				}
			}
		}
	}, {
		key: 'freeze',
		value: function freeze() {
			this._isFrozen = true;
		}
	}, {
		key: 'unfreeze',
		value: function unfreeze() {
			this._isFrozen = false;
		}
	}, {
		key: 'hide',
		value: function hide() {
			'use strict';

			this.alpha = 0;
			this._isVisible = false;
		}
	}, {
		key: 'show',
		value: function show() {
			'use strict';

			this.alpha = 1;
			this._isVisible = this.isVisible;
		}

		/**
   * @deprecated Does not work without app width/height
   * @returns {boolean}
   */

	}, {
		key: 'onAdd',
		value: function onAdd(scene) {
			'use strict';

			this.parentScene = scene;
		}
	}, {
		key: 'destroy',
		value: function destroy() {
			if (this.onDestroy) this.onDestroy();
			if (this.parentScene) this.parentScene.removeChild(this);
		}
	}, {
		key: 'onDestroy',
		value: function onDestroy() {
			/* To be overridden*/
		}
	}, {
		key: 'onRemove',
		value: function onRemove() {
			/* To be overridden*/
		}
	}, {
		key: 'endStep',
		value: function endStep() {
			/* To be overridden*/
		}
	}, {
		key: 'onCollide',
		value: function onCollide() {
			/* To be overridden*/
		}
	}, {
		key: 'physicsStep',
		value: function physicsStep() {
			/* To be overridden*/
		}
	}, {
		key: 'isFrozen',
		get: function get() {
			return this._isFrozen;
		}
	}, {
		key: 'vX',
		get: function get() {
			return this._vX;
		},
		set: function set(val) {
			this._vX = val;
		}
	}, {
		key: 'vY',
		get: function get() {
			return this._vY;
		},
		set: function set(val) {
			this._vY = val;
		}
	}, {
		key: 'x',
		set: function set(val) {
			this.position.x = val;
		},
		get: function get() {
			return this.position.x;
		}
	}, {
		key: 'y',
		set: function set(val) {
			this.position.y = val;
		},
		get: function get() {
			'use strict';

			return this.position.y;
		}
	}, {
		key: 'z',
		set: function set(val) {
			this.zOrder = val;
		},
		get: function get() {
			return this.zOrder;
		}
	}, {
		key: 'isVisible',
		get: function get() {
			'use strict';

			var result = void 0;

			var w = typeof Settings !== 'undefined' ? Settings.PIXI.applicationSettings.width : 720;
			var h = typeof Settings !== 'undefined' ? Settings.PIXI.applicationSettings.height : 1280;

			if (this.parentScene) {
				if (this.x < this.parentScene.position.x + w && this.x + this.texture.width > this.parentScene.position.x && this.y < this.parentScene.position.y + h && this.y + this.texture.height > this.parentScene.position.y) {
					result = true;
				} else result = false;
			} else if (this.alpha > 0) {
				result = true;
			}

			if (this.alpha <= 0) {
				result = false;
			}

			this._isVisible = result;
			return result;
		}
	}]);

	return NineSliceObject;
}(PIXI.mesh.NineSlicePlane);

module.exports = NineSliceObject;