'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// This will house save data to send to GS

var SaveDataHandler = function () {
	function SaveDataHandler(api, props) {
		_classCallCheck(this, SaveDataHandler);

		this.api = api;

		this._data = null;
		this._hasLoaded = false;
		this.defaultSaveData = typeof Settings !== 'undefined' && Settings.SaveData && Settings.SaveData.defaultSaveData ? Settings.SaveData.defaultSaveData : { 'testVal': 1 };

		if (props) Object.assign(this, props);
	}

	_createClass(SaveDataHandler, [{
		key: 'initialize',
		value: function initialize(callback, onFail) {
			'use strict';

			var self = this;

			if (!callback) this.callback = function () {};else this.callback = callback;

			if (!onFail) this.onFail = function () {};else this.onFail = onFail;

			this._data = this.defaultSaveData;

			var keys = [];
			for (var k in this._data) {
				keys.push(k);
			}

			try {
				console.log('[SaveDataHandler] Loading save data...');
				FBInstant.player.getDataAsync(keys).then(function (data) {
					for (var _k in data) {
						if (data.hasOwnProperty(_k)) self._data[_k] = data[_k];
					}
					console.log('[SaveDataHandler] Save data loaded');
					self._hasLoaded = true;
					self.callback();
				});
			} catch (err) {
				console.error('[SaveDataHandler] Failed to load save data for reason: ' + err);
				console.error(err.stack);
				self.onFail();
			}
		}
	}, {
		key: 'saveKey',


		/**
   * Symbolic function for semantics
   * @param key
   * @param value
   */
		value: function saveKey(key, value) {
			this.saveData(key, value);
		}
	}, {
		key: 'saveData',
		value: function saveData(key, value) {
			'use strict';

			if (!this._hasLoaded) return;

			if (this._data.hasOwnProperty(key)) this._data[key] = value;

			try {
				FBInstant.player.setDataAsync(this._data).then(function () {
					console.log("[SaveDataHandler] Save data key '" + key + "' saved with value: " + value.toString());
				});
			} catch (err) {
				console.error('[SaveDataHandler] Failed to save data for reason: ' + err);
				console.error(err.stack);
			}
		}
	}, {
		key: 'hasLoaded',
		get: function get() {
			return this._hasLoaded;
		}
	}, {
		key: 'data',
		get: function get() {
			return this._data;
		}
	}]);

	return SaveDataHandler;
}();

module.exports = SaveDataHandler;